/**
 * Copyright (c) 2009 TIBCO Software Inc. and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v2.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v20.html
 * 
 * Contributors: 
 *   Adrian Price
 */
package org.eclipse.emf.test.models.switch3;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.test.models.switch2.Switch2Package;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.eclipse.emf.test.models.switch3.Switch3Factory
 * @model kind="package"
 * @generated
 */
public interface Switch3Package extends EPackage
{
  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "switch3";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "http:///org.eclipse.emf.test.models/switch3";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "s3";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  Switch3Package eINSTANCE = org.eclipse.emf.test.models.switch3.impl.Switch3PackageImpl.init();

  /**
   * The meta object id for the '{@link org.eclipse.emf.test.models.switch3.impl.EClass4Impl <em>EClass4</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.eclipse.emf.test.models.switch3.impl.EClass4Impl
   * @see org.eclipse.emf.test.models.switch3.impl.Switch3PackageImpl#getEClass4()
   * @generated
   */
  int ECLASS4 = 0;

  /**
   * The feature id for the '<em><b>EAttribute0</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ECLASS4__EATTRIBUTE0 = Switch2Package.ECLASS3__EATTRIBUTE0;

  /**
   * The feature id for the '<em><b>EAttribute1</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ECLASS4__EATTRIBUTE1 = Switch2Package.ECLASS3__EATTRIBUTE1;

  /**
   * The feature id for the '<em><b>EAttribute2</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ECLASS4__EATTRIBUTE2 = Switch2Package.ECLASS3__EATTRIBUTE2;

  /**
   * The feature id for the '<em><b>EAttribute3</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ECLASS4__EATTRIBUTE3 = Switch2Package.ECLASS3__EATTRIBUTE3;

  /**
   * The feature id for the '<em><b>EAttribute4</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ECLASS4__EATTRIBUTE4 = Switch2Package.ECLASS3__EATTRIBUTE4;

  /**
   * The feature id for the '<em><b>EAttribute5</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ECLASS4__EATTRIBUTE5 = Switch2Package.ECLASS3__EATTRIBUTE5;

  /**
   * The feature id for the '<em><b>EAttribute6</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ECLASS4__EATTRIBUTE6 = Switch2Package.ECLASS3__EATTRIBUTE6;

  /**
   * The feature id for the '<em><b>EAttribute7</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ECLASS4__EATTRIBUTE7 = Switch2Package.ECLASS3__EATTRIBUTE7;

  /**
   * The feature id for the '<em><b>EAttribute8</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ECLASS4__EATTRIBUTE8 = Switch2Package.ECLASS3_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>EAttribute9</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ECLASS4__EATTRIBUTE9 = Switch2Package.ECLASS3_FEATURE_COUNT + 1;

  /**
   * The number of structural features of the '<em>EClass4</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ECLASS4_FEATURE_COUNT = Switch2Package.ECLASS3_FEATURE_COUNT + 2;

  /**
   * The meta object id for the '{@link org.eclipse.emf.test.models.switch3.impl.EClass5Impl <em>EClass5</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.eclipse.emf.test.models.switch3.impl.EClass5Impl
   * @see org.eclipse.emf.test.models.switch3.impl.Switch3PackageImpl#getEClass5()
   * @generated
   */
  int ECLASS5 = 1;

  /**
   * The feature id for the '<em><b>EAttribute0</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ECLASS5__EATTRIBUTE0 = ECLASS4__EATTRIBUTE0;

  /**
   * The feature id for the '<em><b>EAttribute1</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ECLASS5__EATTRIBUTE1 = ECLASS4__EATTRIBUTE1;

  /**
   * The feature id for the '<em><b>EAttribute2</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ECLASS5__EATTRIBUTE2 = ECLASS4__EATTRIBUTE2;

  /**
   * The feature id for the '<em><b>EAttribute3</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ECLASS5__EATTRIBUTE3 = ECLASS4__EATTRIBUTE3;

  /**
   * The feature id for the '<em><b>EAttribute4</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ECLASS5__EATTRIBUTE4 = ECLASS4__EATTRIBUTE4;

  /**
   * The feature id for the '<em><b>EAttribute5</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ECLASS5__EATTRIBUTE5 = ECLASS4__EATTRIBUTE5;

  /**
   * The feature id for the '<em><b>EAttribute6</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ECLASS5__EATTRIBUTE6 = ECLASS4__EATTRIBUTE6;

  /**
   * The feature id for the '<em><b>EAttribute7</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ECLASS5__EATTRIBUTE7 = ECLASS4__EATTRIBUTE7;

  /**
   * The feature id for the '<em><b>EAttribute8</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ECLASS5__EATTRIBUTE8 = ECLASS4__EATTRIBUTE8;

  /**
   * The feature id for the '<em><b>EAttribute9</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ECLASS5__EATTRIBUTE9 = ECLASS4__EATTRIBUTE9;

  /**
   * The feature id for the '<em><b>EAttribute10</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ECLASS5__EATTRIBUTE10 = ECLASS4_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>EAttribute11</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ECLASS5__EATTRIBUTE11 = ECLASS4_FEATURE_COUNT + 1;

  /**
   * The number of structural features of the '<em>EClass5</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ECLASS5_FEATURE_COUNT = ECLASS4_FEATURE_COUNT + 2;


  /**
   * Returns the meta object for class '{@link org.eclipse.emf.test.models.switch3.EClass4 <em>EClass4</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>EClass4</em>'.
   * @see org.eclipse.emf.test.models.switch3.EClass4
   * @generated
   */
  EClass getEClass4();

  /**
   * Returns the meta object for the attribute '{@link org.eclipse.emf.test.models.switch3.EClass4#getEAttribute8 <em>EAttribute8</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>EAttribute8</em>'.
   * @see org.eclipse.emf.test.models.switch3.EClass4#getEAttribute8()
   * @see #getEClass4()
   * @generated
   */
  EAttribute getEClass4_EAttribute8();

  /**
   * Returns the meta object for the attribute '{@link org.eclipse.emf.test.models.switch3.EClass4#getEAttribute9 <em>EAttribute9</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>EAttribute9</em>'.
   * @see org.eclipse.emf.test.models.switch3.EClass4#getEAttribute9()
   * @see #getEClass4()
   * @generated
   */
  EAttribute getEClass4_EAttribute9();

  /**
   * Returns the meta object for class '{@link org.eclipse.emf.test.models.switch3.EClass5 <em>EClass5</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>EClass5</em>'.
   * @see org.eclipse.emf.test.models.switch3.EClass5
   * @generated
   */
  EClass getEClass5();

  /**
   * Returns the meta object for the attribute '{@link org.eclipse.emf.test.models.switch3.EClass5#getEAttribute10 <em>EAttribute10</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>EAttribute10</em>'.
   * @see org.eclipse.emf.test.models.switch3.EClass5#getEAttribute10()
   * @see #getEClass5()
   * @generated
   */
  EAttribute getEClass5_EAttribute10();

  /**
   * Returns the meta object for the attribute '{@link org.eclipse.emf.test.models.switch3.EClass5#getEAttribute11 <em>EAttribute11</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>EAttribute11</em>'.
   * @see org.eclipse.emf.test.models.switch3.EClass5#getEAttribute11()
   * @see #getEClass5()
   * @generated
   */
  EAttribute getEClass5_EAttribute11();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  Switch3Factory getSwitch3Factory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link org.eclipse.emf.test.models.switch3.impl.EClass4Impl <em>EClass4</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.eclipse.emf.test.models.switch3.impl.EClass4Impl
     * @see org.eclipse.emf.test.models.switch3.impl.Switch3PackageImpl#getEClass4()
     * @generated
     */
    EClass ECLASS4 = eINSTANCE.getEClass4();

    /**
     * The meta object literal for the '<em><b>EAttribute8</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ECLASS4__EATTRIBUTE8 = eINSTANCE.getEClass4_EAttribute8();

    /**
     * The meta object literal for the '<em><b>EAttribute9</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ECLASS4__EATTRIBUTE9 = eINSTANCE.getEClass4_EAttribute9();

    /**
     * The meta object literal for the '{@link org.eclipse.emf.test.models.switch3.impl.EClass5Impl <em>EClass5</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.eclipse.emf.test.models.switch3.impl.EClass5Impl
     * @see org.eclipse.emf.test.models.switch3.impl.Switch3PackageImpl#getEClass5()
     * @generated
     */
    EClass ECLASS5 = eINSTANCE.getEClass5();

    /**
     * The meta object literal for the '<em><b>EAttribute10</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ECLASS5__EATTRIBUTE10 = eINSTANCE.getEClass5_EAttribute10();

    /**
     * The meta object literal for the '<em><b>EAttribute11</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ECLASS5__EATTRIBUTE11 = eINSTANCE.getEClass5_EAttribute11();

  }

} //Switch3Package
